// PCMDecoder.cpp
//

#include <memory.h>
#include "PCMDecoder.h"
#include <string.h>

namespace Dix {
	//! RXgN^
	PCMDecoder::PCMDecoder() :
		isLoop_			( false ),
		isReady_		( false ),
		channelNum_		( 0 ),
		samplingRate_	( 0 ),
		bitRate_		( 0 )
	{
	}

	//! fXgN^
	PCMDecoder::~PCMDecoder() {
	}

	//! NA
	void PCMDecoder::clear() {
		isLoop_ = false;
		isReady_ = false;
		channelNum_ = 0;
		samplingRate_ = 0;
		bitRate_ = 0;
	}

	//! [vtO擾
	bool PCMDecoder::isLoop() {
		return isLoop_;
	}

	//! łH
	bool PCMDecoder::isReady() {
		return isReady_;
	}

	//! [vݒ
	void PCMDecoder::setLoop( bool isLoop ) {
		isLoop_ = isLoop;
	}

	//! WAVEFORMATEX\̂擾
	bool PCMDecoder::getWaveFormatEx( WAVEFORMATEX& waveFormatEx ) {
		if ( isReady() == false ) {
			return false;
		}

		waveFormatEx.wFormatTag			= WAVE_FORMAT_PCM;
		waveFormatEx.nChannels			= channelNum_;
		waveFormatEx.nSamplesPerSec		= samplingRate_;
		waveFormatEx.wBitsPerSample		= bitRate_;
		waveFormatEx.nBlockAlign		= channelNum_ * bitRate_ / 8;
		waveFormatEx.nAvgBytesPerSec	= waveFormatEx.nSamplesPerSec * waveFormatEx.nBlockAlign;
		waveFormatEx.cbSize				= 0;

		return true;
	}

	//! tOݒ
	void PCMDecoder::setReady( bool isReady ) {
		isReady_ = isReady;
	}

	//! `lݒ
	void PCMDecoder::setChannelNum( unsigned int channelNum ) {
		channelNum_ = channelNum;
	}

	//! TvO[gݒ
	void PCMDecoder::setSamplingRate( unsigned int samplingRate ) {
		samplingRate_ = samplingRate;
	}

	//! rbg[gݒ
	void PCMDecoder::setBitRate( unsigned int bitRate ) {
		bitRate_ = bitRate;
	}

}