// PCMPlayer.h
//

#ifndef IKD_DIX_PCMPLAYER_H
#define IKD_DIX_PCMPLAYER_H

#include "DixSmartPtr.h"
#include "PCMDecoder.h"
#include "DixComPtr.h"
#include "dsound.h"

namespace Dix {
	class PCMPlayer {
	public:
		// Đ
		enum STATE {
			STATE_NONE,
			STATE_PLAY,
			STATE_PAUSE,
			STATE_STOP
		};

	public:
		PCMPlayer();
		PCMPlayer( Com_ptr< IDirectSound8 > cpDS8 );
		PCMPlayer( Com_ptr< IDirectSound8 > cpDS8, sp< PCMDecoder > spDecoder );

		~PCMPlayer();

		//! foCXݒ
		void setDevice( Com_ptr< IDirectSound8 > cpDS8 );

		//! PCMfR[_ݒ
		bool setDecoder( sp< PCMDecoder > pcmDecoder );

		//! Đ
		bool play( bool isLoop );

		//! ꎞ~
		void pause();

		//! ~
		void stop();

		//! ʂς
		void setVolume( int volume );

		//! p̈ʒuς
		void setPan( int pan );

		//! NA
		void clear();

		//! Ԏ擾
		STATE getState();


	private:
		//! Đ̃Xbh~
		void terminateThread();

		//! obt@
		bool initializeBuffer();

		//! obt@Rs[Xbh
		static void __cdecl streamThread( void* player );

		//! łH
		bool isReady();

		//! ĐH
		bool isPlaying();


	private:
		sp< PCMDecoder >				spPCMDecoder_;		//!< ĐΏۃfR[h
		WAVEFORMATEX					waveFormat_;		//!< WAVEFORMATEX\
		DSBUFFERDESC					DSBufferDesc_;		//!< DSBUFFERDESC\
		Com_ptr< IDirectSound8 >		cpDS8_;				//!< TEhfoCX
		Com_ptr< IDirectSoundBuffer8 >	cpDSBuffer_;		//!< ZJ_obt@
		bool							isReady_;			//!< łH
		unsigned int					threadHandle_;		//!< Xg[ĐXbhnh
		bool							isTerminate_;		//!< Xbh~
		bool							isLoop_;			//!< [vH
		STATE							state_;				//!< Đ
	};
}

#endif